import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { GetEarthObservationJobOutputFilterSensitiveLog, } from "../models/models_0";
import { de_GetEarthObservationJobCommand, se_GetEarthObservationJobCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class GetEarthObservationJobCommand extends $Command
    .classBuilder()
    .ep(commonParams)
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("SageMakerGeospatial", "GetEarthObservationJob", {})
    .n("SageMakerGeospatialClient", "GetEarthObservationJobCommand")
    .f(void 0, GetEarthObservationJobOutputFilterSensitiveLog)
    .ser(se_GetEarthObservationJobCommand)
    .de(de_GetEarthObservationJobCommand)
    .build() {
}
