import { SENSITIVE_STRING } from "@smithy/smithy-client";
import { SageMakerGeospatialServiceException as __BaseException } from "./SageMakerGeospatialServiceException";
export class AccessDeniedException extends __BaseException {
    name = "AccessDeniedException";
    $fault = "client";
    Message;
    constructor(opts) {
        super({
            name: "AccessDeniedException",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, AccessDeniedException.prototype);
        this.Message = opts.Message;
    }
}
export const AlgorithmNameCloudRemoval = {
    INTERPOLATION: "INTERPOLATION",
};
export const AlgorithmNameGeoMosaic = {
    AVERAGE: "AVERAGE",
    BILINEAR: "BILINEAR",
    CUBIC: "CUBIC",
    CUBICSPLINE: "CUBICSPLINE",
    LANCZOS: "LANCZOS",
    MAX: "MAX",
    MED: "MED",
    MIN: "MIN",
    MODE: "MODE",
    NEAR: "NEAR",
    Q1: "Q1",
    Q3: "Q3",
    RMS: "RMS",
    SUM: "SUM",
};
export const AlgorithmNameResampling = {
    AVERAGE: "AVERAGE",
    BILINEAR: "BILINEAR",
    CUBIC: "CUBIC",
    CUBICSPLINE: "CUBICSPLINE",
    LANCZOS: "LANCZOS",
    MAX: "MAX",
    MED: "MED",
    MIN: "MIN",
    MODE: "MODE",
    NEAR: "NEAR",
    Q1: "Q1",
    Q3: "Q3",
    RMS: "RMS",
    SUM: "SUM",
};
export var AreaOfInterestGeometry;
(function (AreaOfInterestGeometry) {
    AreaOfInterestGeometry.visit = (value, visitor) => {
        if (value.PolygonGeometry !== undefined)
            return visitor.PolygonGeometry(value.PolygonGeometry);
        if (value.MultiPolygonGeometry !== undefined)
            return visitor.MultiPolygonGeometry(value.MultiPolygonGeometry);
        return visitor._(value.$unknown[0], value.$unknown[1]);
    };
})(AreaOfInterestGeometry || (AreaOfInterestGeometry = {}));
export var AreaOfInterest;
(function (AreaOfInterest) {
    AreaOfInterest.visit = (value, visitor) => {
        if (value.AreaOfInterestGeometry !== undefined)
            return visitor.AreaOfInterestGeometry(value.AreaOfInterestGeometry);
        return visitor._(value.$unknown[0], value.$unknown[1]);
    };
})(AreaOfInterest || (AreaOfInterest = {}));
export const OutputType = {
    FLOAT32: "FLOAT32",
    FLOAT64: "FLOAT64",
    INT16: "INT16",
    INT32: "INT32",
    UINT16: "UINT16",
};
export const ComparisonOperator = {
    EQUALS: "EQUALS",
    NOT_EQUALS: "NOT_EQUALS",
    STARTS_WITH: "STARTS_WITH",
};
export class ConflictException extends __BaseException {
    name = "ConflictException";
    $fault = "client";
    Message;
    ResourceId;
    constructor(opts) {
        super({
            name: "ConflictException",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, ConflictException.prototype);
        this.Message = opts.Message;
        this.ResourceId = opts.ResourceId;
    }
}
export const DataCollectionType = {
    PREMIUM: "PREMIUM",
    PUBLIC: "PUBLIC",
    USER: "USER",
};
export class InternalServerException extends __BaseException {
    name = "InternalServerException";
    $fault = "server";
    Message;
    ResourceId;
    constructor(opts) {
        super({
            name: "InternalServerException",
            $fault: "server",
            ...opts,
        });
        Object.setPrototypeOf(this, InternalServerException.prototype);
        this.Message = opts.Message;
        this.ResourceId = opts.ResourceId;
    }
}
export class ResourceNotFoundException extends __BaseException {
    name = "ResourceNotFoundException";
    $fault = "client";
    Message;
    ResourceId;
    constructor(opts) {
        super({
            name: "ResourceNotFoundException",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, ResourceNotFoundException.prototype);
        this.Message = opts.Message;
        this.ResourceId = opts.ResourceId;
    }
}
export class ThrottlingException extends __BaseException {
    name = "ThrottlingException";
    $fault = "client";
    Message;
    ResourceId;
    constructor(opts) {
        super({
            name: "ThrottlingException",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, ThrottlingException.prototype);
        this.Message = opts.Message;
        this.ResourceId = opts.ResourceId;
    }
}
export class ValidationException extends __BaseException {
    name = "ValidationException";
    $fault = "client";
    Message;
    ResourceId;
    constructor(opts) {
        super({
            name: "ValidationException",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, ValidationException.prototype);
        this.Message = opts.Message;
        this.ResourceId = opts.ResourceId;
    }
}
export const EarthObservationJobExportStatus = {
    FAILED: "FAILED",
    IN_PROGRESS: "IN_PROGRESS",
    SUCCEEDED: "SUCCEEDED",
};
export class ServiceQuotaExceededException extends __BaseException {
    name = "ServiceQuotaExceededException";
    $fault = "client";
    Message;
    ResourceId;
    constructor(opts) {
        super({
            name: "ServiceQuotaExceededException",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, ServiceQuotaExceededException.prototype);
        this.Message = opts.Message;
        this.ResourceId = opts.ResourceId;
    }
}
export const EarthObservationJobErrorType = {
    CLIENT_ERROR: "CLIENT_ERROR",
    SERVER_ERROR: "SERVER_ERROR",
};
export const ExportErrorType = {
    CLIENT_ERROR: "CLIENT_ERROR",
    SERVER_ERROR: "SERVER_ERROR",
};
export const LogicalOperator = {
    AND: "AND",
};
export var Property;
(function (Property) {
    Property.visit = (value, visitor) => {
        if (value.EoCloudCover !== undefined)
            return visitor.EoCloudCover(value.EoCloudCover);
        if (value.ViewOffNadir !== undefined)
            return visitor.ViewOffNadir(value.ViewOffNadir);
        if (value.ViewSunAzimuth !== undefined)
            return visitor.ViewSunAzimuth(value.ViewSunAzimuth);
        if (value.ViewSunElevation !== undefined)
            return visitor.ViewSunElevation(value.ViewSunElevation);
        if (value.Platform !== undefined)
            return visitor.Platform(value.Platform);
        if (value.LandsatCloudCoverLand !== undefined)
            return visitor.LandsatCloudCoverLand(value.LandsatCloudCoverLand);
        return visitor._(value.$unknown[0], value.$unknown[1]);
    };
})(Property || (Property = {}));
export const Unit = {
    METERS: "METERS",
};
export const PredefinedResolution = {
    AVERAGE: "AVERAGE",
    HIGHEST: "HIGHEST",
    LOWEST: "LOWEST",
};
export const GroupBy = {
    ALL: "ALL",
    YEARLY: "YEARLY",
};
export const TemporalStatistics = {
    MEAN: "MEAN",
    MEDIAN: "MEDIAN",
    STANDARD_DEVIATION: "STANDARD_DEVIATION",
};
export const ZonalStatistics = {
    MAX: "MAX",
    MEAN: "MEAN",
    MEDIAN: "MEDIAN",
    MIN: "MIN",
    STANDARD_DEVIATION: "STANDARD_DEVIATION",
    SUM: "SUM",
};
export var JobConfigInput;
(function (JobConfigInput) {
    JobConfigInput.visit = (value, visitor) => {
        if (value.BandMathConfig !== undefined)
            return visitor.BandMathConfig(value.BandMathConfig);
        if (value.ResamplingConfig !== undefined)
            return visitor.ResamplingConfig(value.ResamplingConfig);
        if (value.TemporalStatisticsConfig !== undefined)
            return visitor.TemporalStatisticsConfig(value.TemporalStatisticsConfig);
        if (value.CloudRemovalConfig !== undefined)
            return visitor.CloudRemovalConfig(value.CloudRemovalConfig);
        if (value.ZonalStatisticsConfig !== undefined)
            return visitor.ZonalStatisticsConfig(value.ZonalStatisticsConfig);
        if (value.GeoMosaicConfig !== undefined)
            return visitor.GeoMosaicConfig(value.GeoMosaicConfig);
        if (value.StackConfig !== undefined)
            return visitor.StackConfig(value.StackConfig);
        if (value.CloudMaskingConfig !== undefined)
            return visitor.CloudMaskingConfig(value.CloudMaskingConfig);
        if (value.LandCoverSegmentationConfig !== undefined)
            return visitor.LandCoverSegmentationConfig(value.LandCoverSegmentationConfig);
        return visitor._(value.$unknown[0], value.$unknown[1]);
    };
})(JobConfigInput || (JobConfigInput = {}));
export const EarthObservationJobStatus = {
    COMPLETED: "COMPLETED",
    DELETED: "DELETED",
    DELETING: "DELETING",
    FAILED: "FAILED",
    INITIALIZING: "INITIALIZING",
    IN_PROGRESS: "IN_PROGRESS",
    STOPPED: "STOPPED",
    STOPPING: "STOPPING",
};
export const TargetOptions = {
    INPUT: "INPUT",
    OUTPUT: "OUTPUT",
};
export const SortOrder = {
    ASCENDING: "ASCENDING",
    DESCENDING: "DESCENDING",
};
export const VectorEnrichmentJobExportStatus = {
    FAILED: "FAILED",
    IN_PROGRESS: "IN_PROGRESS",
    SUCCEEDED: "SUCCEEDED",
};
export const VectorEnrichmentJobErrorType = {
    CLIENT_ERROR: "CLIENT_ERROR",
    SERVER_ERROR: "SERVER_ERROR",
};
export const VectorEnrichmentJobExportErrorType = {
    CLIENT_ERROR: "CLIENT_ERROR",
    SERVER_ERROR: "SERVER_ERROR",
};
export var VectorEnrichmentJobDataSourceConfigInput;
(function (VectorEnrichmentJobDataSourceConfigInput) {
    VectorEnrichmentJobDataSourceConfigInput.visit = (value, visitor) => {
        if (value.S3Data !== undefined)
            return visitor.S3Data(value.S3Data);
        return visitor._(value.$unknown[0], value.$unknown[1]);
    };
})(VectorEnrichmentJobDataSourceConfigInput || (VectorEnrichmentJobDataSourceConfigInput = {}));
export const VectorEnrichmentJobDocumentType = {
    CSV: "CSV",
};
export var VectorEnrichmentJobConfig;
(function (VectorEnrichmentJobConfig) {
    VectorEnrichmentJobConfig.visit = (value, visitor) => {
        if (value.ReverseGeocodingConfig !== undefined)
            return visitor.ReverseGeocodingConfig(value.ReverseGeocodingConfig);
        if (value.MapMatchingConfig !== undefined)
            return visitor.MapMatchingConfig(value.MapMatchingConfig);
        return visitor._(value.$unknown[0], value.$unknown[1]);
    };
})(VectorEnrichmentJobConfig || (VectorEnrichmentJobConfig = {}));
export const VectorEnrichmentJobStatus = {
    COMPLETED: "COMPLETED",
    DELETED: "DELETED",
    DELETING: "DELETING",
    FAILED: "FAILED",
    INITIALIZING: "INITIALIZING",
    IN_PROGRESS: "IN_PROGRESS",
    STOPPED: "STOPPED",
    STOPPING: "STOPPING",
};
export const VectorEnrichmentJobType = {
    MAP_MATCHING: "MAP_MATCHING",
    REVERSE_GEOCODING: "REVERSE_GEOCODING",
};
export const MultiPolygonGeometryInputFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.Coordinates && { Coordinates: obj.Coordinates.map((item) => item.map((item) => SENSITIVE_STRING)) }),
});
export const PolygonGeometryInputFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.Coordinates && { Coordinates: obj.Coordinates.map((item) => SENSITIVE_STRING) }),
});
export const AreaOfInterestGeometryFilterSensitiveLog = (obj) => {
    if (obj.PolygonGeometry !== undefined)
        return { PolygonGeometry: PolygonGeometryInputFilterSensitiveLog(obj.PolygonGeometry) };
    if (obj.MultiPolygonGeometry !== undefined)
        return { MultiPolygonGeometry: MultiPolygonGeometryInputFilterSensitiveLog(obj.MultiPolygonGeometry) };
    if (obj.$unknown !== undefined)
        return { [obj.$unknown[0]]: "UNKNOWN" };
};
export const AreaOfInterestFilterSensitiveLog = (obj) => {
    if (obj.AreaOfInterestGeometry !== undefined)
        return { AreaOfInterestGeometry: AreaOfInterestGeometryFilterSensitiveLog(obj.AreaOfInterestGeometry) };
    if (obj.$unknown !== undefined)
        return { [obj.$unknown[0]]: "UNKNOWN" };
};
export const TimeRangeFilterOutputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const RasterDataCollectionQueryOutputFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.TimeRangeFilter && { TimeRangeFilter: SENSITIVE_STRING }),
    ...(obj.AreaOfInterest && { AreaOfInterest: AreaOfInterestFilterSensitiveLog(obj.AreaOfInterest) }),
    ...(obj.PropertyFilters && { PropertyFilters: obj.PropertyFilters }),
});
export const InputConfigOutputFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.RasterDataCollectionQuery && {
        RasterDataCollectionQuery: RasterDataCollectionQueryOutputFilterSensitiveLog(obj.RasterDataCollectionQuery),
    }),
});
export const GetEarthObservationJobOutputFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.InputConfig && { InputConfig: InputConfigOutputFilterSensitiveLog(obj.InputConfig) }),
    ...(obj.JobConfig && { JobConfig: obj.JobConfig }),
});
export const GetTileOutputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const ListEarthObservationJobInputFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.NextToken && { NextToken: SENSITIVE_STRING }),
});
export const ListEarthObservationJobOutputFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.NextToken && { NextToken: SENSITIVE_STRING }),
});
export const TimeRangeFilterInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const RasterDataCollectionQueryInputFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.TimeRangeFilter && { TimeRangeFilter: SENSITIVE_STRING }),
    ...(obj.AreaOfInterest && { AreaOfInterest: AreaOfInterestFilterSensitiveLog(obj.AreaOfInterest) }),
    ...(obj.PropertyFilters && { PropertyFilters: obj.PropertyFilters }),
});
export const InputConfigInputFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.RasterDataCollectionQuery && {
        RasterDataCollectionQuery: RasterDataCollectionQueryInputFilterSensitiveLog(obj.RasterDataCollectionQuery),
    }),
});
export const StartEarthObservationJobInputFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.InputConfig && { InputConfig: InputConfigInputFilterSensitiveLog(obj.InputConfig) }),
    ...(obj.JobConfig && { JobConfig: obj.JobConfig }),
});
export const StartEarthObservationJobOutputFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.InputConfig && { InputConfig: InputConfigOutputFilterSensitiveLog(obj.InputConfig) }),
    ...(obj.JobConfig && { JobConfig: obj.JobConfig }),
});
export const GeometryFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.Coordinates && { Coordinates: obj.Coordinates.map((item) => SENSITIVE_STRING) }),
});
export const ItemSourceFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.Geometry && { Geometry: GeometryFilterSensitiveLog(obj.Geometry) }),
});
export const ListRasterDataCollectionsInputFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.NextToken && { NextToken: SENSITIVE_STRING }),
});
export const ListRasterDataCollectionsOutputFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.NextToken && { NextToken: SENSITIVE_STRING }),
});
export const ListVectorEnrichmentJobInputFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.NextToken && { NextToken: SENSITIVE_STRING }),
});
export const ListVectorEnrichmentJobOutputFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.NextToken && { NextToken: SENSITIVE_STRING }),
});
export const RasterDataCollectionQueryWithBandFilterInputFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.TimeRangeFilter && { TimeRangeFilter: SENSITIVE_STRING }),
    ...(obj.AreaOfInterest && { AreaOfInterest: AreaOfInterestFilterSensitiveLog(obj.AreaOfInterest) }),
    ...(obj.PropertyFilters && { PropertyFilters: obj.PropertyFilters }),
});
export const SearchRasterDataCollectionInputFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.RasterDataCollectionQuery && {
        RasterDataCollectionQuery: RasterDataCollectionQueryWithBandFilterInputFilterSensitiveLog(obj.RasterDataCollectionQuery),
    }),
    ...(obj.NextToken && { NextToken: SENSITIVE_STRING }),
});
export const SearchRasterDataCollectionOutputFilterSensitiveLog = (obj) => ({
    ...obj,
    ...(obj.NextToken && { NextToken: SENSITIVE_STRING }),
    ...(obj.Items && { Items: obj.Items.map((item) => ItemSourceFilterSensitiveLog(item)) }),
});
